<template>
  <div class="">
    <v-menu bottom :offset-y="true">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="switchLang v-menu-btn" text v-bind="attrs" v-on="on">
          <img class="v-menu-icon me-1" :src="flag(lang)" :alt="lang" />
          <span>{{ lang }}</span>
          <span class="mdi mdi-chevron-down"></span>
        </v-btn>
      </template>

      <v-list>
        <v-list-item
          dense
          class="v-menu-list-item"
          v-for="locale in recentLocales"
          :key="locale"
          @click="selectLang(locale)"
        >
          <v-list-item-title class="d-flex justify-space-around align-center">
            <img class="v-menu-icon me-1" :src="flag(locale)" :alt="locale" />
            <span>{{ locale }}</span>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
  name: "SwitchLang",
  data() {
    return {
      flags: [
        {
          code: "en",
          icon: require("@/assets/img/app/flags/us-flag.webp"),
        },
        {
          code: "fa",
          icon: require("@/assets/img/app/flags/ir-flag.webp"),
        },
      ],
    };
  },

  computed: {
    ...mapGetters({
      locales: "lang/locales",
      lang: "lang/lang",
    }),

    recentLocales() {
      return this.locales.filter((i) => i !== this.lang);
    },
  },

  methods: {
    ...mapActions({
      setLang: "lang/setI18nLang",
      setFont: "lang/setSiteFont",
    }),
    selectLang(code) {
      this.$vuetify.rtl = code === "fa";
      this.setFont(code);
      this.setLang(code);
    },

    flag(code) {
      return this.flags.find((flag) => flag.code === code).icon;
    },
  },
};
</script>

<style lang="scss" scoped>
.langListItem {
  min-height: 10px;
  cursor: pointer;
}

.switchLang {
  width: 70px;
}

img {
  width: 24px;
  height: 24px;
  border-radius: 50%;
}
</style>
